"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var angular_2_local_storage_1 = require("angular-2-local-storage");
var Observable_1 = require("rxjs/Observable");
var index_1 = require("./index");
var HttpClient = (function () {
    function HttpClient(http, localStorageService, loaderService) {
        this.http = http;
        this.localStorageService = localStorageService;
        this.loaderService = loaderService;
    }
    HttpClient.prototype.createAuthorizationHeader = function (headers) {
        if (this.localStorageService.get('id_token') != null) {
            headers.append('Authorization', this.localStorageService.get('id_token'));
        }
    };
    HttpClient.prototype.get = function (url) {
        var _this = this;
        this.showLoader();
        var headers = new http_1.Headers();
        this.createAuthorizationHeader(headers);
        return this.http.get(url, {
            headers: headers
        })
            .map(function (x) { return x.json(); })
            .catch(this.onCatch)
            .do(function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })
            .finally(function () {
            _this.onEnd();
        });
    };
    HttpClient.prototype.post = function (url, data) {
        var _this = this;
        this.showLoader();
        var headers = new http_1.Headers();
        this.createAuthorizationHeader(headers);
        return this.http.post(url, data, {
            headers: headers
        }).catch(this.onCatch)
            .do(function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })
            .finally(function () {
            _this.onEnd();
        });
    };
    HttpClient.prototype.postWithCredentials = function (url, data) {
        var _this = this;
        this.showLoader();
        return this.http.post(url, {}, { headers: index_1.contentHeaders, withCredentials: true })
            .catch(this.onCatch)
            .do(function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })
            .finally(function () {
            _this.onEnd();
        });
    };
    HttpClient.prototype.put = function (url, data) {
        var _this = this;
        this.showLoader();
        var headers = new http_1.Headers();
        this.createAuthorizationHeader(headers);
        return this.http.put(url, data, {
            headers: headers
        }).catch(this.onCatch)
            .do(function (res) {
            _this.onSuccess(res);
        }, function (error) {
            _this.onError(error);
        })
            .finally(function () {
            _this.onEnd();
        });
    };
    HttpClient.prototype.onCatch = function (error, caught) {
        return Observable_1.Observable.throw(error);
    };
    HttpClient.prototype.onSuccess = function (res) {
        console.log('Request successful');
    };
    HttpClient.prototype.onError = function (res) {
        console.log('Error, status code: ' + res.status);
    };
    HttpClient.prototype.onEnd = function () {
        this.hideLoader();
    };
    HttpClient.prototype.showLoader = function () {
        this.loaderService.show();
    };
    HttpClient.prototype.hideLoader = function () {
        this.loaderService.hide();
    };
    return HttpClient;
}());
HttpClient = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [http_1.Http, angular_2_local_storage_1.LocalStorageService, index_1.LoaderService])
], HttpClient);
exports.HttpClient = HttpClient;
//# sourceMappingURL=httpClient.service.js.map